<?php
/*************************************************************************************************
 * Copyright 2018 JPL TSolucio, S.L. -- This file is a part of TSOLUCIO coreBOS customizations.
 * You can copy, adapt and distribute the work under the "Attribution-NonCommercial-ShareAlike"
 * Vizsage Public License (the "License"). You may not use this file except in compliance with the
 * License. Roughly speaking, non-commercial users may share and modify this code, but must give credit
 * and share improvements. However, for proper details please read the full License, available at
 * http://vizsage.com/license/Vizsage-License-BY-NC-SA.html and the handy reference for understanding
 * the full license at http://vizsage.com/license/Vizsage-Deed-BY-NC-SA.html. Unless required by
 * applicable law or agreed to in writing, any software distributed under the License is distributed
 * on an  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and limitations under the
 * License terms of Creative Commons Attribution-NonCommercial-ShareAlike 3.0 (the License).
 *************************************************************************************************/

class convertState2Picklist extends cbupdaterWorker {

	public function applyChange() {
		if ($this->hasError()) {
			$this->sendError();
		}
		if ($this->isApplied()) {
			$this->sendMsg('Changeset '.get_class($this).' already applied!');
		} else {
			global $adb;
			$importLang = 'es';
			$cspath = 'build/changeSets/imported';
			$if = $cspath.'/States_'.$importLang.'.csv';
			$counties = $plvals = file($if, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
			$modules = array(
				'Invoice' => array('bill_state', 'ship_state'),
				'Quotes' => array('bill_state', 'ship_state'),
				'PurchaseOrder' => array('bill_state', 'ship_state'),
				'SalesOrder' => array('bill_state', 'ship_state'),
				'Issuecards' => array('bill_state', 'ship_state'),
				'Accounts' => array('bill_state', 'ship_state'),
				'Contacts' => array('mailingstate', 'otherstate'),
				'Leads' => array('state'),
				'Vendors' => array('state'),
			);
			foreach ($modules as $module => $fields) {
				foreach ($fields as $field) {
					$this->convertTextFieldToPicklist($field, $module);
				}
			}
			$uniqmodules = array(
				'Invoice' => array('bill_state', 'ship_state'),
				'Contacts' => array('mailingstate', 'otherstate'),
				'Vendors' => array('state'),
			);
			foreach ($uniqmodules as $module => $fields) {
				foreach ($fields as $fieldname) {
					$moduleInstance = Vtiger_Module::getInstance($module);
					if ($moduleInstance) {
						$field = Vtiger_Field::getInstance($fieldname, $moduleInstance);
						if ($field) {
							$field->setPicklistValues($counties);
						}
					}
				}
			}

			$this->sendMsg('Changeset '.get_class($this).' applied!');
			$this->markApplied(false);
		}
		$this->finishExecution();
	}
}
